#ifndef GLOBALS_H
#define GLOBALS_H

#include <QString>
#include <QStringList>

#include <cmath>
#include <cstdio>
#include <iostream>

#include <limits.h>
#include <time.h>
#include <vector>
using namespace std;

#include "KmUtils.h"
#include "../../clus_globals.h"

namespace km
{
    int LoadPointsFromFile(const QString& filename,
                           int window_begin, int window_end, int samples_begin, int samples_end,
                           int& num_records, int& num_samples, Scalar*& records);
    int WriteCluFile(const QString& filename, int k, const int* assignments, const Scalar* centers,
                     int num_records, int num_samples);
}

#endif // GLOBALS_H
