#ifndef KMEANSTO_H
#define KMEANSTO_H

#include <QThread>
#include "globals.h"
#include "KMeans.h"

class ThreadMgr;

class KMeansTO : public QObject
{
    Q_OBJECT

    public:
        KMeansTO(ThreadMgr* tmgr, int num_records, int k, int num_samples,
                 Scalar* records, int num_attempts, bool is_only_cluster);
//        KMeansTO(int num_records, int k, int num_samples, Scalar* records, int num_attempts);

    signals:
        void Finished(int k, const int* assignments, const Scalar* centers);

    public slots:
        void Start();

    private:
        int _numRecords, _k, _numSamples, _numAttempts;
        Scalar* _records;
        ThreadMgr* _threadMgr;
};

#endif // KMEANSTO_H
