#include "klustakwikto.h"

KlustaKwikTO::KlustaKwikTO(wv::CLUSTER_ID cid, wv::TRANSFORM transform,
                           MatCPtr waves, const std::string& wfm_file)
    : ClusMethodTOBase(cid, transform, waves, waves->size1, wfm_file)
{    
//    MakeProgressBar(Name());
}

void KlustaKwikTO::Start()
{
    StartTimer();

    //Get the parameters
    StringList proc_args;
    std::string path = InputPathStub();
#ifndef Q_OS_UNIX
    std::replace(path.begin(), path.end(), '/', '\\');
#endif
    proc_args << path;
    proc_args << std::to_string( ID() );
    proc_args << std::to_string( Electrode() );
    proc_args << std::to_string( WindowBegin() )
            << std::to_string( WindowEnd() );
        //The subset of records actually being used in the clustering.  Use fseek
    int num_pars = Params()->NumPars();
    for (int i=0; i<num_pars; ++i)
        proc_args << Params()->Value(i);

    QProcess* clus_proc = new QProcess(); //Must create here, so that it is in this thread
    Cluster(clus_proc, proc_args);
}
