#ifndef SPC_TO_H
#define SPC_TO_H

#include "clusmethodtobase.h"
#include "../../memrep/classification.h"
#include "../../memrep/parameters/cluster/spcparameters.h"
#include "../../file/input/spcfilein.h"
#include "../../file/output/mclufileout.h"

class SPC_TO : public ClusMethodTOBase
{
    Q_OBJECT

    public:
        SPC_TO(wv::CLUSTER_ID cid, wv::TRANSFORM transform, MatCPtr waves,
                     const std::string& wfm_file);
        virtual ~SPC_TO() override {}

        int TemperatureIndex(const wv_matrix_int* cluster_counts, int min_clus_size, int clus_size_thresh);
        int RefineClusters(wv_vector_int* new_vclus, const wv_vector_int* vclus);
            //Assumes new_vclus has already been allocated

        virtual std::string Name() const override { return "SPC"; }
        virtual wv::CLUSTER_METHOD Method() const override { return wv::SPC; }

    public slots:
        virtual void Start() override;

    protected slots:
        virtual void LoadClassification(int exit_code) override;
};

#endif // SPC_TO_H
