#ifndef COVARIANCETO_H
#define COVARIANCETO_H

#include "../../globals/qt_headers.h"
#include "../../globals/gsl_headers.h"

class CovThreadMgr;

class CovarianceTO : public QObject
{
    Q_OBJECT

    public:
        struct CovSpec
        {
            size_t j1, j2;
            const double* data1, * data2;
            size_t stride1, stride2;
                //Have to break it down like this or else things will get overwritten
        };

        CovarianceTO(CovThreadMgr* thread_mgr, size_t num_rows);

        void Enqueue(const CovSpec& cov_spec);

    signals:
        void ThreadComplete();

    public slots:
        void Start();
        void Finished();

    private:
        CovThreadMgr* _threadMgr;
        QQueue<CovSpec> _queue;
        volatile bool _isRunning;
        size_t _numRows;

        QMutex _mutex;
};

#endif // COVARIANCETO_H
