#ifndef COVTHREADMGR_H
#define COVTHREADMGR_H

#include "../../globals/qt_headers.h"
#include "covarianceto.h"

class SleeperThread : public QThread
{
    public:
        static void Sleep(ulong msec) { msleep(msec); }
};

class CovThreadMgr : public QObject
{
    Q_OBJECT

    public:
        CovThreadMgr(const gsl_matrix* input_mat, gsl_matrix* cov_mat);
        ~CovThreadMgr();

        void Calculate();
        void SetResult(size_t j1, size_t j2, double covariance);

    signals:
        void StartThread();
        void Finished();

    public slots:
        void ThreadComplete();

    private:
        int _numThreads;
        QList<QThread*> _threads;
        QList<CovarianceTO*> _covarianceTOs;
        int _tasksRemaining; //The number of covariances left to calculate
        volatile int _numActiveThreads;

        const gsl_matrix* _inputMat;
        gsl_matrix* _covMat;

        QMutex _mutex;
};

#endif // COVTHREADMGR_H
