#ifndef ALIGNMENTMGR_H
#define ALIGNMENTMGR_H

#include "threadmgr.h"

//This parallelizes the circular shift required in WaveData::AlignWaveforms
class AlignmentMgr : public ThreadMgr
{
    public:
        struct AlignmentSpec
        {
            AlignmentSpec(wv_matrix* raw_, const wv_vector_int* offsets_) :
                i_start(-1), i_end(-1), raw(raw_), offsets(offsets_)
            {}
            size_t i_start, i_end;
            wv_matrix* raw;
            const wv_vector_int* offsets;
        };

        explicit AlignmentMgr(AlignmentSpec& alignment_spec);

        virtual WorkerTO* CreateWorkerTO(int thd_num) override;

    private:
        AlignmentSpec _alignmentSpec;
        int _recordsPerThread;
};

#endif // ALIGNMENTMGR_H
