#include "containsmgr.h"
#include "../worker/containsto.h"

ContainsMgr::ContainsMgr(ContainsSpec& contains_spec, wv_vector_int* vcluster)
    : ThreadMgr(QThread::idealThreadCount(), 25000),
      _containsSpec(contains_spec), _vCluster(vcluster)
{
    int num_records = _containsSpec.transform_x->size1;
    _recordsPerThread = num_records / NumThreads();
}

WorkerTO* ContainsMgr::CreateWorkerTO(int thd_num)
{
    int i_start = thd_num*_recordsPerThread;
    _containsSpec.i_start = i_start;
    _containsSpec.i_end = (thd_num==NumThreads()-1)
            ? _containsSpec.transform_x->size1
            : i_start+_recordsPerThread;
    ContainsTO* to = new ContainsTO(thd_num, _containsSpec, _vCluster);
    return to;
}

