#ifndef COVTHREADMGR_H
#define COVTHREADMGR_H

#include "../../../globals/qt_headers.h"
#include "../worker/covarianceto.h"
#include "threadmgr.h"

class CovThreadMgr : public ThreadMgr
{
    Q_OBJECT

    public:
        CovThreadMgr(const wv_matrix* input_mat, wv_matrix* cov_mat);
        virtual ~CovThreadMgr() override;

        virtual WorkerTO* CreateWorkerTO(int thd_num) override;

    private:
        const wv_matrix* _inputMat;
        wv_vector* _columnMeans; //Precompute the mean of each column vector
        wv_matrix* _covMat;
};

#endif // COVTHREADMGR_H
