#ifndef DIFFMGR_H
#define DIFFMGR_H

#include "threadmgr.h"

//This parallelizes the differentiation of the waveforms in WaveData::MakeDiff
class DiffMgr : public ThreadMgr
{
    public:
        struct DiffSpec
        {
            DiffSpec(const wv_matrix* raw_, wv_matrix* rawd, wv_matrix* sloped) :
                i_start(-1), i_end(-1), raw(raw_), raw_d(rawd), slope_d(sloped)
            {}
            bool do_smooth;
            size_t i_start, i_end;
            const wv_matrix* raw;
            wv_matrix* raw_d,
                * slope_d;
            wv::float_t us_per_samp;
        };

        explicit DiffMgr(DiffSpec& diff_spec);

        virtual WorkerTO* CreateWorkerTO(int thd_num) override;

    private:
        DiffSpec _diffSpec;
        int _recordsPerThread;
};

#endif // DIFFMGR_H
