#ifndef WAVELETMGR_H
#define WAVELETMGR_H

#include "threadmgr.h"
#include "../../../memrep/parameters/profile.h"
#ifdef USE_GSL
#include "../../../analysis/gsl_utils/mgsl.h"
#endif

class HaarMgr : public ThreadMgr
{
    public:
        struct HaarSpec
        {
            HaarSpec(const wv_matrix* waves_);
            bool is_centered;
            size_t i_start, i_end;
            int size; //-1 for Haar; even numbers for Daubechies
            wv_matrix* transform;
            const wv_matrix* waves;
        };

        explicit HaarMgr(HaarSpec& haar_spec); //Non const because it also contains writeable members.  Could
            //break this in two, but don't want to bother...

        virtual WorkerTO* CreateWorkerTO(int thd_num) override;

    private:
        HaarSpec _haarSpec;
        int _recordsPerThread;
};

#endif // WAVELETMGR_H
