#ifndef HISTTHREADMGR_H
#define HISTTHREADMGR_H

#include "../../../globals/globals.h"
#include "../../../memrep/specs/wavespaceguispec.h"
#include "../../../memrep/specs/histspec.h"
#include "../mgr/threadmgr.h"

class WorkerTO;
class HistThreadMgr : public ThreadMgr
{
    public:
        explicit HistThreadMgr(const HistSpec& hist_spec);

        virtual WorkerTO* CreateWorkerTO(int thd_num) override;
        wv_histogram2d* HistAccept() { return _histAccept; }
        wv_histogram2d* HistUnaccept() { return _histUnaccept; }

    protected:
        virtual void OnThreadFinished(void* result) override;

    private:
        const HistSpec& _histSpec;
        wv_histogram2d* _histAccept, * _histUnaccept;
        int _recordsPerThread;
};

#endif // HISTTHREADMGR_H
