#include "histwgtscattermgr.h"
#include "../worker/histwgtscatterto.h"
#include "../../../gui/widgets/histwidget.h"

HistWgtScatterMgr::HistWgtScatterMgr(uchar* pixels, const HistWidget* hist_widget) : ThreadMgr(qMax( QThread::idealThreadCount()-1, 1), 2000),
      _pixels(pixels), _histWidget(hist_widget)
{
}
WorkerTO* HistWgtScatterMgr::CreateWorkerTO(int thd_num)
{
    int hist_ht = _histWidget->HistHeight(),
            cols_per_thread = hist_ht / NumThreads();
    int jstart = thd_num * cols_per_thread,
            jend = (thd_num== NumThreads()-1)
            ? hist_ht
            : jstart + cols_per_thread;
    HistWgtScatterTO* to = new HistWgtScatterTO(thd_num, _pixels, _histWidget, jstart, jend);
    return to;
}
