#include "splinemgr.h"
#include "../worker/splineworkerto.h"

SplineMgr::SplineMgr(SplineSpec& spec) : ThreadMgr(QThread::idealThreadCount(), 25000),
    _spec(spec)
{
    int num_records = _spec.waves->size1,
            num_samples = _spec.waves->size2;
    _recordsPerThread = num_records / NumThreads();
    _spec.spline = wv_matrix_alloc(num_records, num_samples);
    _spec.height = wv_matrix_alloc(num_records, 1);
    _spec.width = wv_matrix_alloc(num_records, 1);
    _spec.slope = wv_matrix_alloc(num_records, 1);
}

WorkerTO* SplineMgr::CreateWorkerTO(int thd_num)
{
    int i_start = thd_num*_recordsPerThread;
    _spec.i_start = i_start;
    _spec.i_end = (thd_num==NumThreads()-1) ? _spec.waves->size1 : i_start+_recordsPerThread;
    SplineWorkerTO* to = new SplineWorkerTO(thd_num, _spec);
    return to;
}
