#ifndef THREADMGR_H
#define THREADMGR_H

#include "../../../globals/globals.h"

class Sleeper : public QThread
{
public:
    static void sleep_us(unsigned long us)
    {
        QThread::usleep(us);
    }
};

class WorkerTO;
class ThreadMgr : public QObject
{
    Q_OBJECT
    public:
        explicit ThreadMgr(int num_threads, int us_sleep);

        void StartThreads();
        void Wait();

        int NumThreads() { return _numThreads; }

    signals:
        void Start();

    public slots:
        void ThreadFinished(int thd_num, void* result);

    protected:
        virtual ~ThreadMgr() override;
        virtual WorkerTO* CreateWorkerTO(int thd_num) = 0;
        virtual void OnThreadFinished(void*) {}

    private:
        bool IsIncomplete();

        int _numThreads, _usSleep;
        std::vector<QThread*> _threads;
        std::list<WorkerTO*> _workers;
        std::mutex _mutex;
};

#endif // THREADMGR_H
