#ifndef COVARIANCETO_H
#define COVARIANCETO_H

#include "../../../globals/qt_headers.h"
#include "workerto.h"

class CovThreadMgr;

class CovarianceTO : public WorkerTO
{
    Q_OBJECT

    public:
        struct CovSpec
        {
            size_t j1, j2;
            const wv::float_t* data1, * data2;
            wv::float_t mean1, mean2;
            size_t stride1, stride2;
                //Have to break it down like this or else things will get overwritten
        };

        CovarianceTO(int thd_num, std::list<CovSpec> cov_specs, size_t num_rows, wv_matrix* cov_mat);

    public slots:
        void Start();

    private:
        std::list<CovSpec> _covSpecs;
        size_t _numRows;
        wv_matrix* _covMat;
};

#endif // COVARIANCETO_H
