#include "fourierto.h"
#include "../../memrep/wavedata.h"

FourierTO::FourierTO(MatCPtr waves, const std::string& file_name, short electrode, ParamsBase *pars, bool is_raw)
    : TransformTOBase(waves, file_name, electrode, pars, is_raw)
{
//    MakeProgressBar(file_name);
}

void FourierTO::Start()
{
    const wv_matrix* waves = Waves().get();
    FourierMgr::FourierSpec fourier_spec(waves);
    FourierMgr mgr(fourier_spec);

    mgr.StartThreads();
    mgr.Wait();

    MatPtr transform = MatPtr(fourier_spec.transform, wv_matrix_free);
    auto pair = new std::pair<wv::TRANSFORM, MatPtr>( Transform(), transform );
    AnalysisFinished(pair);
}
