#ifndef FOURIERTO_H
#define FOURIERTO_H

#include "../../globals/globals.h"
#include "transformtobase.h"
#include "../threads/mgr/fouriermgr.h"

class WaveData;

class FourierTO : public TransformTOBase
{
    Q_OBJECT

    public:
        explicit FourierTO(MatCPtr waves, const std::string& file_name,
                           short electrode, ParamsBase* pars, bool is_raw);
        virtual ~FourierTO() override {}

        virtual std::string Name() const override { return (IsRaw()) ? "fourier" : "fourier_d"; }
        virtual wv::TRANSFORM Transform() const override { return (IsRaw()) ? wv::FOURIER : wv::FOURIER_D; }

    public slots:
        virtual void Start() override;

};

#endif // FOURIERTO_H
