#include "haarto.h"

HaarTO::HaarTO(MatCPtr waves, const std::string& file_name, short electrode, ParamsBase* pars, bool is_raw)
    : TransformTOBase(waves, file_name, electrode, pars, is_raw)
{
//    MakeProgressBar(file_name);
}

void HaarTO::Start()
{
    const wv_matrix* waves = Waves().get();
    HaarMgr::HaarSpec haar_spec(waves);
    HaarMgr mgr(haar_spec);

    mgr.StartThreads();
    mgr.Wait();

    MatPtr transform = MatPtr(haar_spec.transform, wv_matrix_free);
    auto pair = new std::pair<wv::TRANSFORM, MatPtr>( Transform(), transform );
    AnalysisFinished(pair);
}
