#include "clufilein.h"

CluFileIn::CluFileIn(we::CLUSTER_ID id, const QString& file_name, const QBitArray& window)
    : InputFileBase(file_name, false), _id(id), _window(window)
{
}
CluFileIn::~CluFileIn()
{
    delete static_cast<Classification*>( Data() );
}

int CluFileIn::Load()
{
    int num_records = _window.size(),
            max_class;
    gsl_vector_int* vcluster = gsl_vector_int_alloc(num_records);

    //Now get the cluster values, both putting them in the big num_records-length
    FILE* clu = File();
    if (clu)
    {
        fscanf(clu, "%d\n", &max_class);
        int code = gsl_vector_int_fscanf(clu, vcluster);
        if (code) Log("ERROR: Did not read cluster temporary file correctly");
    }
    else
    {
        Log("WARNING: Invalid file name, " + Path() + ", no records loaded.");
        return -1;
    }

    //Now create the classification
    SetData( new Classification(_id, max_class, vcluster) );

    return num_records;
}
