#ifndef SPCFILEIN_H
#define SPCFILEIN_H

#include "inputfilebase.h"

class SPCFileIn : public InputFileBase
{
    public:
        typedef std::pair<wv::float_t, wv_vector_int*> ClusPair;

        SPCFileIn(const std::string& file_name);
        virtual ~SPCFileIn() override;

        virtual int Load() override;

        wv::float_t Temperature(int i);// const;
        const wv_vector_int* VCluster(int i);// const;
        const wv_matrix_int* ClusterCounts() const { return _clusterCounts; }

    private:
        static const int NUM_HEADER_COLS;

        std::string _fileNameBase;
        std::map<std::string, std::string> _outputParams;
        wv_matrix_int* _clusterCounts; //Essentially the output of the .dg_01
            //file; each row corresponds to a temperature level.
};

#endif // SPCFILEIN_H
