#ifndef MEXFILE_H
#define MEXFILE_H

#include "waveformsinbase.h"

class MexFile : public WaveformsInBase
{
    friend WaveformsInBase* WaveformsInBase::Create(const std::string&);

    public:
        virtual ~MexFile() override {}
        virtual int Load() override;

    protected:
        MexFile(const std::string& name);

    private:
        struct MexRecord
        {
            uint timestamp;
            short electrode;
            short online_clus;
            short rex_flag;
            short wave_length;
            short* wave;
        };

        int ReadHeader();
        void ReadWaveforms();

        static const int HEADER_SIZE,
                    MAX_WAVE_LEN;

        std::string _header;
        int _numRecordBytes,
            _adZero, _adMin, _adMax,
            _numRecordsTotal;
        std::string _variables; //Time, Electrode, (Spike), Flag, Length
            //Probably not necessary, _isTESFL is all that is needed
        bool _isTESFL;
};

#endif // MEXFILE_H
