#include "hd2fileout.h"

Hd2FileOut::Hd2FileOut(const std::string& file_name, wv::TRANSFORM transform, int samples_range, const wv_vector* err_vec)
    : OutputFileBase(file_name, false, NULL, boost::dynamic_bitset<>()),
      _transform(transform), _samplesRange(samples_range), _errors(err_vec)
{
}

void Hd2FileOut::Save() const
{
    FILE* fp = File();
    if (fp)
    {
        fprintf(fp, "num_db2_format_defs %d\n", 2);
        fprintf(fp, "number_of_attributes %d\n", _samplesRange);
        fprintf(fp, "separator_char '\\t'\n");

        char transform[256];
        strcpy(transform, wv::TransformName(_transform).c_str());
        for (int j=0; j<_samplesRange; ++j)
        {
            wv::float_t error = wv_vector_get(_errors, j);
            fprintf(fp, "%d real location %s error %lf\n", j, transform, error);
        }
    }
    else
        Log("WARNING: Invalid file name, " + Name() + ", no records loaded.");
}
