#ifndef MCLUFILEOUT_H
#define MCLUFILEOUT_H

#include "outputfilebase.h"

// 'M' for 'multi'--writes out a set of clusters, one for each 'level'--# of clusters for KMeans,
// temperature for SPC
class MCluFileOut : public OutputFileBase
{
    public:
        MCluFileOut(const std::string& file_name, const Classification* cls);
        MCluFileOut(const std::string& file_name, int best, const std::vector<ConstClustering>& clusterings);
        MCluFileOut(const std::string& file_name, int best, const wv_vector_int* vcluster);

        virtual void Save() const override;

    private:
        int _best; //Best clustering (integer index, not level)
        std::vector<ConstClustering> _clusters; //std::list< std::pair<wv::float_t, wv_vector_int*> >
};

#endif // MCLUFILEOUT_H
