#ifndef OUTPUTFILEBASE_H
#define OUTPUTFILEBASE_H

#include "../filebase.h"
#include "../input/inputfilebase.h"
#include "../../memrep/classification.h"
//#include <sys/stat.h>  //Useful for debugging

class OutputFileBase : public FileBase
{
    public:
        OutputFileBase(const std::string& name, bool is_binary,
                   const WaveData* data, const boost::dynamic_bitset<>& accepted);
        virtual void Save() const = 0;

    protected:
        const WaveData* Data() const { return _data; }
        bool IsAccepted(int i) const { return _accepted.test(i); }

    private:
        const WaveData* _data;
        const boost::dynamic_bitset<> _accepted; //Remember these can represent multiple selected clusters
};

#endif // OUTPUTFILEBASE_H
