#ifndef PROFILEOUT_H
#define PROFILEOUT_H

#include "outputfilebase.h"
#include "../input/profilein.h"
#include "../../memrep/parameters/profile.h"

class ProfileOut : public OutputFileBase
{
    public:
        ProfileOut(const std::string& list_name = "", const ParamVec& param_list = ParamVec());
            //A list name required because ProfileOut optionally saves only one list
            //at a time.  This way parameter changes from a particular list can be saved
            //without saving every change currently made in the gui.

        virtual void Save() const override;

    private:
        void Write(FILE* fp) const;

        std::string _listName;
        ParamVec _paramList;
};

#endif // PROFILEOUT_H
