#ifndef SIMPLEBINARY_H
#define SIMPLEBINARY_H

#include "outputfilebase.h"

//The output file packs accepted/not accepted for 8 records into each byte
class SimpleBinary : public OutputFileBase
{
    public:
        SimpleBinary(const std::string& name, const WaveData* data, const boost::dynamic_bitset<>& accepted);
        virtual void Save() const override;

    private:
        static const int BYTE_SZ;
        uchar* _byteArray; //So we can actually write to the file
        int _numAllRecords, _numBytes;
};

#endif // SIMPLEBINARY_H
