#ifndef USERCLUFILEOUT_H
#define USERCLUFILEOUT_H

#include "outputfilebase.h"

class UserCluFileOut : public OutputFileBase
{
    public:
        UserCluFileOut(const std::string& file_name, wv::CLUSTER_ID cid);
        virtual ~UserCluFileOut() override;

        virtual void Save() const override;

        wv::CLUSTER_ID CID() const { return _cid; }

    protected:
        virtual int WriteRows() const;

        const wv_vector_int* AllClusters() const { return _allClusters; }

    private:
        wv_vector_int* _allClusters;
        wv::CLUSTER_ID _cid;
        ClassificationCPtr _class;
        int _level;
};

#endif // USERCLUFILEOUT_H
