#include "usertclufileout.h"
#include "../../memrep/clustermediator.h"

UserTCluFileOut::UserTCluFileOut(const std::string& file_name, wv::CLUSTER_ID cid)
    : UserCluFileOut(file_name, cid)
{
}

int UserTCluFileOut::WriteRows() const
{
    FILE* clu = File();
    ClusterMediator& cmed = ClusterMediator::Instance();
    WaveData* wave_data = cmed.GetWaveData( CID() );
    const wv_vector_int* all_clusters = AllClusters(),
            * all_timestamps = wave_data->AllTimestamps();
    int num_records = all_clusters->size;

    for (int i=0; i<num_records; ++i)
        fprintf(clu, "%d\t%d\n", wv_vector_int_get(all_timestamps, i),
                wv_vector_int_get(all_clusters, i));
    return 0;
}
