#include "wfmfileout.h"

WfmFileOut::WfmFileOut(const std::string& filename, MatCPtr waves, const FileBase::WfmHeader& header,
                       bool header_only)
    : OutputFileBase(filename, true, NULL, boost::dynamic_bitset<>(waves->size1)),
      _header(header), _headerOnly(header_only), _waves(waves)
{
}

void WfmFileOut::Save() const
{
    FILE* temp = File();
    if (temp)
    {
        fwrite(&_header, sizeof(FileBase::WfmHeader), 1, temp);
        if (!_headerOnly) wv_matrix_fwrite(temp, _waves.get());
    }
    else
        throw BadFileName("WfmFileOut::Save", Path());
}
