#include "tempfilebase.h"
#include "filebase.h"

const double TempFileBase::_memoryLimit = 25.0; //% of memory allowed

TempFileBase::TempFileBase()
{
}

std::string TempFileBase::MakeTempFileName(const std::string& users_dir, const std::string& user_name, const std::string& input_file_name,
                             wv::TRANSFORM transform, wv::CLUSTER_ID cid, const std::string& type, int electrode)
{
    std::string tr = wv::TransformName(transform);
    return users_dir + "/" + user_name + "/temp/~" + input_file_name + "." + tr + "."
            + std::to_string(cid) + "." + type + "." + std::to_string(electrode);
}
std::string TempFileBase::MakeTempFileName(const std::string& full_path, const std::string& input_file_name,
                             wv::TRANSFORM transform, wv::CLUSTER_ID cid, const std::string& type, int electrode)
{
    std::string user_dir(""),
            name("");
    int pos = full_path.find_last_of('/');
    if (pos==-1)
        name = full_path;
    else
    {
        user_dir = full_path.substr(0,pos);
        name = full_path.substr(pos+1);
    }
    return MakeTempFileName(user_dir, name, input_file_name, transform, cid, type, electrode);
}
void TempFileBase::TempFileComponents(const std::string& temp_file, std::string& user_dir, std::string& name, wv::TRANSFORM& transform,
                            wv::CLUSTER_ID& cid, int& electrode)
{
    int pos = temp_file.find_last_of("/temp/");
    user_dir = temp_file.substr(0, pos);
    int name_pos = temp_file.find_first_of('~', pos+1) + 1; //The first letter after temp/~
    std::string full_name = temp_file.substr(name_pos);
    StringVec elts = ut::Split(full_name, ".");
    int num_elts = elts.size(); //The filename itself can have .'s in it, so need to be careful
    name = "";
    for (int i=0; i<num_elts-4; ++i)
        name += elts.at(i) + ".";
    name.erase( name.size()-1 ); //Get rid of the last .
    std::string ts = elts.at(num_elts-4);
    transform = wv::TransformEnumVal(ts);
    cid = boost::lexical_cast<int>( elts.at(num_elts-3) );
    electrode = boost::lexical_cast<int>( elts.at(num_elts-1) ); //"wfm" or "clu" is element n-2
}

bool TempFileBase::IsEnoughMemory()
{
/*    long long int pid = QApplication::applicationPid();
    std::string memfile = std::string(FileBase::UserPath() + "/pid%1.txt").arg(pid);
    std::string cmd = std::string("ps -p %1 -o pmem > " + memfile).arg(pid);
    system(cmd.c_str());
    FILE* fp = fopen(memfile.c_str(), "r");
    if (!fp)
    {
        Log("ERROR: Could not read mem file, assuming over quota");
        return false;
    }
    char* spec = (char*)malloc(sizeof(char)*256);
    size_t num_bytes;
//    getline(&spec, &num_bytes, fp); //Don't really care about this. Should be %MEM
//    getline(&spec, &num_bytes, fp);
    double mem = boost::lexical_cast<double>(spec);

    fclose(fp);

//    return mem < _memoryLimit;
*/
    return true;
}
