#ifndef TEMPFILEBASE_H
#define TEMPFILEBASE_H

#include "../globals/globals.h"

class TempFileBase
{
    public:
        TempFileBase();

        static std::string MakeTempFileName(const std::string& users_dir, const std::string& user_name, const std::string& input_file_name, wv::TRANSFORM transform,
                                 wv::CLUSTER_ID cid, const std::string& type, int electrode);
        static std::string MakeTempFileName(const std::string& full_path, const std::string& input_file_name, wv::TRANSFORM transform,
                                 wv::CLUSTER_ID cid, const std::string& type, int electrode);
        static void TempFileComponents(const std::string& temp_file, std::string& user_dir,
                                 std::string& name, wv::TRANSFORM& transform, wv::CLUSTER_ID& cid, int& eletrode);
            //Convenience. **Note that these functions expect whatever folder is supplied to contain a 'temp' directory, in which
            //the file is to be found/put.  'type' is wfm, tim, or clu
        static bool IsEnoughMemory();

    private:
        static const double _memoryLimit;
};

typedef TempFileBase TFB;

#endif // TEMPFILEBASE_H
