#include "wfmfileappend.h"

const int WfmFileAppend::BUFFER_SIZE = 1024*1024;
WfmFileAppend::WfmFileAppend(const std::string& filename)
    : FileBase(filename, QIODevice::Append, true), _buffer( new char[BUFFER_SIZE] )
{
//    setvbuf(File(), _buffer, _IOFBF, BUFFER_SIZE);
    Close();
}
WfmFileAppend::~WfmFileAppend()
{
    fflush(File());
    delete _buffer;
}

void WfmFileAppend::Append(const wv_matrix* mat, int num_to_write) const
{
    Reopen();
    FILE* temp = File();
    if (temp)
    {
        setvbuf(File(), _buffer, _IOFBF, BUFFER_SIZE);

        int num_rows = mat->size1,
                num_pts = mat->size2;
        if (num_to_write==-1)
            fwrite(mat->data, sizeof(wv::float_t), num_rows*num_pts, temp);
        else
            for (int i=0; i<num_to_write; ++i)
            {
                wv_vector_const_view v = wv_matrix_const_row(mat, i);
                fwrite(v.vector.data, sizeof(wv::float_t), num_pts, temp);
            }
    }
    else
        throw BadFileName("WfmFileAppend::Append", Path());
    Close();
}
