#ifndef GLOBALS_H
#define GLOBALS_H

#include "boost_headers.h"
#ifdef USE_GSL
#include "gsl_headers.h"
#else
#include "msl_headers.h"
#endif
#include "qt_headers.h"
#include "stl_headers.h"

#include "wv.h"
#include "wexception.h"
#include "ut_def.h"

namespace wv
{
#ifdef USE_GSL
    typedef double              float_t;
#else
    typedef MATH_DEFAULT_T      float_t;
#endif
}

typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned short ushort;
const double DOUBLE_MAX = std::numeric_limits<double>::max();
typedef unsigned long long ULL;

typedef std::shared_ptr<wv_matrix> MatPtr;
typedef std::shared_ptr<const wv_matrix> MatCPtr;
typedef std::shared_ptr<wv_vector> VecPtr;
typedef std::shared_ptr<const wv_vector> VecCPtr;

#endif // GLOBALS_H
