#ifndef GSL_HEADERS_H
#define GSL_HEADERS_H

#define GSL_DISABLE_DEPRECATED

#include <gsl/gsl_matrix.h>
#include <gsl/gsl_vector.h>
#include <gsl/gsl_vector_int.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_statistics.h>
#include <gsl/gsl_sort_vector.h>

#include <gsl/gsl_histogram.h>
#include <gsl/gsl_histogram2d.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_eigen.h>
#include <gsl/gsl_linalg.h>
#include <gsl/gsl_interp.h>
#include <gsl/gsl_fft_real.h>
#include <gsl/gsl_fft_halfcomplex.h>
#include <gsl/gsl_wavelet.h>
#include <gsl/gsl_spline.h>
#include <gsl/gsl_bspline.h>
#include <gsl/gsl_multifit.h>

typedef     gsl_vector                                          wv_vector;
typedef     gsl_vector_view                                     wv_vector_view;
typedef     gsl_vector_const_view                               wv_vector_const_view;
typedef     gsl_vector_int                                      wv_vector_int;
typedef     gsl_vector_int_view                                 wv_vector_int_view;
typedef     gsl_vector_int_const_view                           wv_vector_int_const_view;
typedef     gsl_matrix                                          wv_matrix;
typedef     gsl_matrix_int                                      wv_matrix_int;
typedef     gsl_matrix_view                                     wv_matrix_view;
typedef     gsl_matrix_const_view                               wv_matrix_const_view;

#define     wv_matrix_add                                       gsl_matrix_add
#define     wv_matrix_add_constant                              gsl_matrix_add_constant
#define     wv_matrix_alloc                                     gsl_matrix_alloc
#define     wv_matrix_clone                                     gsl_matrix_clone
#define     wv_matrix_calloc                                    gsl_matrix_calloc
#define     wv_matrix_column                                    gsl_matrix_column
#define     wv_matrix_const_column                              gsl_matrix_const_column
#define     wv_matrix_const_submatrix                           gsl_matrix_const_submatrix
#define     wv_matrix_const_row                                 gsl_matrix_const_row
#define     wv_matrix_fread                                     gsl_matrix_fread
#define     wv_matrix_free                                      gsl_matrix_free
#define     wv_matrix_fwrite                                    gsl_matrix_fwrite
#define     wv_matrix_get                                       gsl_matrix_get
#define     wv_matrix_get_row                                   gsl_matrix_get_row
#define     wv_matrix_int_add                                   gsl_matrix_int_add
#define     wv_matrix_int_alloc                                 gsl_matrix_int_alloc
#define     wv_matrix_int_free                                  gsl_matrix_int_free
#define     wv_matrix_int_get                                   gsl_matrix_int_get
#define     wv_matrix_int_set                                   gsl_matrix_int_set
#define     wv_matrix_int_set_zero                              gsl_matrix_int_set_zero
#define     wv_matrix_max                                       gsl_matrix_max
#define     wv_matrix_min                                       gsl_matrix_min
#define     wv_matrix_memcpy                                    gsl_matrix_memcpy
#define     wv_matrix_row                                       gsl_matrix_row
#define     wv_matrix_scale                                     gsl_matrix_scale
#define     wv_matrix_set                                       gsl_matrix_set
#define     wv_matrix_set_col                                   gsl_matrix_set_col
#define     wv_matrix_set_row                                   gsl_matrix_set_row
#define     wv_matrix_set_zero                                  gsl_matrix_set_zero
#define     wv_matrix_submatrix                                 gsl_matrix_submatrix

#define     wv_vector_add                                       gsl_vector_add
#define     wv_vector_add_constant                              gsl_vector_add_constant
#define     wv_vector_alloc                                     gsl_vector_alloc
#define     wv_vector_clone                                     gsl_vector_clone
#define     wv_vector_const_subvector                           gsl_vector_const_subvector
#define     wv_vector_const_subvector_with_stride               gsl_vector_const_subvector_with_stride
#define     wv_vector_fread                                     gsl_vector_fread
#define     wv_vector_free                                      gsl_vector_free
#define     wv_vector_fprintf                                   gsl_vector_fprintf
#define     wv_vector_fscanf                                    gsl_vector_fscanf
#define     wv_vector_fwrite                                    gsl_vector_fwrite
#define     wv_vector_get                                       gsl_vector_get
#define     wv_vector_int_add_constant                          gsl_vector_int_add_constant
#define     wv_vector_int_alloc                                 gsl_vector_int_alloc
#define     wv_vector_int_free                                  gsl_vector_int_free
#define     wv_vector_int_fscanf                                gsl_vector_int_fscanf
#define     wv_vector_int_get                                   gsl_vector_int_get
#define     wv_vector_int_memcpy                                gsl_vector_int_memcpy
#define     wv_vector_int_fread                                 gsl_vector_int_fread
#define     wv_vector_int_fprintf                               gsl_vector_int_fprintf
#define     wv_vector_int_fwrite                                gsl_vector_int_fwrite
#define     wv_vector_int_set                                   gsl_vector_int_set
#define     wv_vector_int_set_all                               gsl_vector_int_set_all
#define     wv_vector_max                                       gsl_vector_max
#define     wv_vector_max_index                                 gsl_vector_max_index
#define     wv_vector_memcpy                                    gsl_vector_memcpy
#define     wv_vector_min                                       gsl_vector_min
#define     wv_vector_min_index                                 gsl_vector_min_index
#define     wv_vector_minmax                                    gsl_vector_minmax
#define     wv_vector_minmax_index                              gsl_vector_minmax_index
#define     wv_vector_mul                                       gsl_vector_mul
#define     wv_vector_scale                                     gsl_vector_scale
#define     wv_vector_set                                       gsl_vector_set
#define     wv_vector_set_all                                   gsl_vector_set_all
#define     wv_vector_set_zero                                  gsl_vector_set_zero
#define     wv_vector_sub                                       gsl_vector_sub
#define     wv_vector_subvector                                 gsl_vector_subvector
#define     wv_vector_subvector_with_stride                     gsl_vector_subvector_with_stride
#define     wv_vector_view_array                                gsl_vector_view_array

#define     wv_blas_axpy                                        cblas_daxpy
#define     wv_blas_scal                                        cblas_dscal

#define     wv_stats_covariance(d1,i1,d2,i2,sz)                 gsl_stats_covariance(d1,i1,d2,i2,sz)
#define     wv_stats_covariance_m(d1,i1,d2,i2,sz,m1,m2)         gsl_stats_covariance_m(d1,i1,d2,i2,sz,m1,m2)
#define     wv_stats_max(d,i,sz)                                gsl_stats_max(d,i,sz)
#define     wv_stats_max_index(d,i,sz)                          gsl_stats_max_index(d,i,sz)
#define     wv_stats_mean(d,i,sz)                               gsl_stats_mean(d,i,sz)
#define     wv_stats_min(d,i,sz)                                gsl_stats_min(d,i,sz)
#define     wv_stats_min_index(d,i,sz)                          gsl_stats_min_index(d,i,sz)
#define     wv_stats_minmax(d1,d2,d3,i,sz)                      gsl_stats_minmax(d1,d2,d3,i,sz)
#define     wv_stats_sd(d,i,sz)                                 gsl_stats_sd(d,i,sz)
#define     wv_stats_sd_m(d,i,sz,m)                             gsl_stats_sd_m(d,i,sz,m)


typedef     gsl_eigen_symmv_workspace                           wv_eigen_symmv_workspace;

#define     wv_eigen_symmv(m,ev,evc,ws)                         gsl_eigen_symmv(m,ev,evc,ws)
#define     wv_eigen_symmv_alloc(n)                             gsl_eigen_symmv_alloc(n)
#define     wv_eigen_symmv_free(ws)                             gsl_eigen_symmv_free(ws)


typedef     gsl_histogram                                       wv_histogram;
typedef     gsl_histogram2d                                     wv_histogram2d;

#define     wv_histogram_alloc(sz)                              gsl_histogram_alloc(sz)
#define     wv_histogram_bins(h)                                gsl_histogram_bins(h)
#define     wv_histogram_clone(h)                               gsl_histogram_clone(h)
#define     wv_histogram_find(h,d,sz)                           gsl_histogram_find(h,d,sz)
#define     wv_histogram_free(h)                                gsl_histogram_free(h)
#define     wv_histogram_get(h,sz)                              gsl_histogram_get(h,sz)
#define     wv_histogram_get_range(h,sz,d1,d2)                  gsl_histogram_get_range(h,sz,d1,d2)
#define     wv_histogram_increment(h,d)                         gsl_histogram_increment(h,d)
#define     wv_histogram_max_bin(h)                             gsl_histogram_max_bin(h)
#define     wv_histogram_set_ranges_uniform(h,d1,d2)            gsl_histogram_set_ranges_uniform(h,d1,d2)


#define     wv_histogram2d_add(h1,h2)                           gsl_histogram2d_add(h1,h2)
#define     wv_histogram2d_alloc(sz1,sz2)                       gsl_histogram2d_alloc(sz1,sz2)
#define     wv_histogram2d_clone(h)                             gsl_histogram2d_clone(h)
#define     wv_histogram2d_find(h,d1,d2,sz1,sz2)                gsl_histogram2d_find(h,d1,d2,sz1,sz2)
#define     wv_histogram2d_free(h)                              gsl_histogram2d_free(h)
#define     wv_histogram2d_get(h,sz1,sz2)                       gsl_histogram2d_get(h,sz1,sz2)
#define     wv_histogram2d_get_xrange(h,sz,d1,d2)               gsl_histogram2d_get_xrange(h,sz,d1,d2)
#define     wv_histogram2d_get_yrange(h,sz,d1,d2)               gsl_histogram2d_get_yrange(h,sz,d1,d2)
#define     wv_histogram2d_increment(h,d1,d2)                   gsl_histogram2d_increment(h,d1,d2)
#define     wv_histogram2d_max_bin(h,sz1,sz2)                   gsl_histogram2d_max_bin(h,sz1,sz2)
#define     wv_histogram2d_max_val(h)                           gsl_histogram2d_max_val(h)
#define     wv_histogram2d_nx(h)                                gsl_histogram2d_nx(h)
#define     wv_histogram2d_ny(h)                                gsl_histogram2d_ny(h)
#define     wv_histogram2d_set_ranges_uniform(h,d1,d2,d3,d4)    gsl_histogram2d_set_ranges_uniform(h,d1,d2,d3,d4)

#endif // GSL_HEADERS_H
