#include "ut_def.h"

void ut::FillBitset(boost::dynamic_bitset<>& bitset, bool val, int begin, int end)
{
    for (int i=begin; i<end; ++i)
        bitset[i] = val;
}
    //This implementation is absurdly slow but don't want to bother with a proper bitwise version now.

bool ut::Contains(const std::string& str, char c)
{
    return Contains(str, std::string(1, c));
}
bool ut::Contains(const std::string& str, const std::string& substr)
{
    return str.find(substr) != std::string::npos;
}
bool ut::EndsWith(const std::string& str, char c)
{
    if (str.empty()) return false;
    return *(str.end()-1) == c;
}
bool ut::EndsWith(const std::string& str, const std::string& substr)
{
    size_t pos = str.length() - substr.length();
    return str.substr(pos) == substr;
}

QStringList ut::ToQStringList(const StringList& slist)
{
    QStringList qslist;
    for (auto item : slist)
        qslist.push_back( item.c_str() );
    return qslist;
}
StringList ut::ToStringList(const QStringList& qslist)
{
    StringList slist;
    for (auto item : qslist)
        slist.push_back( item.toStdString() );
    return slist;
}

StringList& operator<<(StringList& string_list, const std::string& str)
{
    string_list.push_back(str);
    return string_list;
}
StringVec& operator<<(StringVec& string_vector, const std::string& str)
{
    string_vector.push_back(str);
    return string_vector;
}
