#include "wexception.h"

WException::WException(const std::string& func, const std::string& msg, const std::string& name)
    : _function(func), _message(msg), _name(name)
{
}

const char* WException::what() const throw()
{
    std::string err = "ERROR: " + _name + ": " + _message + " in " + _function
            + ", please report to WaveSorter maintainer";
    return err.c_str();
}

const char* BadData::what() const throw()
{
    std::string err = "ERROR: " + Name() + " in " + Function()
            + " with electrode " + _electrode + ", please report to WaveSorter maintainer";
    return err.c_str();
}

const char* MutexFail::what() const throw()
{
    std::string err = "Warning: " + Name() + " in " + Function()
            + ", operation failed.  Please retry.";
    return err.c_str();
}

const char* NullTransform::what() const throw()
{
    std::string err = "ERROR: " + Name() + " in " + Function()
            + ", please report to WaveSorter maintainer";
    return err.c_str();
}
