#ifndef SLOTMGR_H
#define SLOTMGR_H

#include "../globals/log.h"

namespace gui
{

    template <typename T>
    void Slot(T* obj, void (T::*slot)(bool) )
    {
        obj->setCursor(Qt::WaitCursor);
        try { (obj->*slot)(false); }
        catch (std::exception& e) { Log(e.what()); }
        obj->setCursor(Qt::ArrowCursor);
    }

    template <typename T>
    void Slot2(T* obj, std::function<void(bool)> slot )
    {
        obj->setCursor(Qt::WaitCursor);
        try { slot(false); }
        catch (std::exception& e) { Log(e.what()); }
        obj->setCursor(Qt::ArrowCursor);
    }

}

#endif // SLOTMGR_H
