#ifndef ELECTRODEGUI_H
#define ELECTRODEGUI_H

#include "../../globals/globals.h"
#include "../../globals/log.h"
#include "../../file/input/waves/waveformsinbase.h"
#include "../gui.h"

namespace Ui {
    class ElectrodeGui;
}

class ElectrodeGui : public QWidget
{
    Q_OBJECT

    public:
        explicit ElectrodeGui(QWidget *parent = 0);
        ~ElectrodeGui();

        void SetElectrodes(WavesFilePtr waves_file);
        void SetElectrodeButton(short elc);

        short Electrode() const;

    signals:
        void SetElectrode(short elc, WavesFilePtr waves_file);

    public slots:
        void on_lsElectrodes_currentRowChanged(int i)
        {
            gui::Slot2(this,  std::bind(&ElectrodeGui::OnLsElectrodesCurrentRowChanged,
                               this, i, std::placeholders::_1) );
        }

    private:
        void OnLsElectrodesCurrentRowChanged(int row, bool is_prog = true);
        Ui::ElectrodeGui *ui;
        std::vector<short> _electrodes;
        WavesFilePtr _wavesFile;
};

#endif // ELECTRODEGUI_H
