#include "loggui.h"
#include "ui_loggui.h"

LogGui::LogGui(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::LogGui)
{
    ui->setupUi(this);
}

LogGui::~LogGui()
{
    delete ui;
}

void LogGui::LogMessage(const std::string &message)
{
    MutexLocker lock(_mutex);
    _text += message + "\n";
    ui->txtLog->append( message.c_str() );
    update();
}

void LogGui::on_btnClear_clicked()
{
    MutexLocker lock(_mutex);
    ui->txtLog->clear();
    update();
}
