#include "progressgui.h"
#include "ui_progressgui.h"

ProgressGui* ProgressGui::instance = NULL;

ProgressGui::ProgressGui()
    : ui(new Ui::ProgressGui)
{
    ui->setupUi(this);
    setWindowTitle("Analysis Progress");
}
ProgressGui& ProgressGui::Instance()
{
    if (!instance) instance = new ProgressGui();
    return *instance;
}

ProgressGui::~ProgressGui()
{
    delete ui;
}

void ProgressGui::AddProgressBar(ProgressBar* progress_bar)
{
    MutexLocker lock(_mutex);
    ui->layProgressBars->addWidget(progress_bar, 1);
    update();
    raise();
}
void ProgressGui::RemoveProgressBar(ProgressBar* progress_bar)
{
    MutexLocker lock(_mutex);
    ui->layProgressBars->removeWidget(progress_bar);
}

ProgressGui& pg()
{
    return ProgressGui::Instance();
}

