#ifndef PROFILEGUI_H
#define PROFILEGUI_H

#include "../globals/globals.h"
#include "../file/filebase.h"

namespace Ui {
    class ProfileGui;
}

class ProfileGui : public QWidget
{
    Q_OBJECT

    public:
        explicit ProfileGui(QWidget *parent = 0);
        ~ProfileGui();

    signals:
        void CurrentProfile(const std::string& profile);

    public slots:
        void on_edProfile_editingFinished();
        void on_btnContinue_clicked();
        void on_btnNew_clicked();

    protected:
        void closeEvent(QCloseEvent*);

    private:
        void RetrieveProfile(const std::string& profile);
        std::string GetNewProfileName();
        void MakeProfile(const std::string& profile);
        void MakeTempProfile();

        Ui::ProfileGui *ui;

        StringList _currentProfiles;
        bool _initEntryComplete;
};

#endif // PROFILEGUI_H
