#include "labelwidget.h"

LabelWidget::LabelWidget(QWidget *parent)
    : QWidget(parent), _text("")
{
}

void LabelWidget::paintEvent(QPaintEvent*)
{
    QPainter painter(this);
    painter.setPen(Qt::black);
    painter.setFont( QFont("Arial") );
    switch (_axis)
    {
        case WSGSpec::X:
            painter.translate(width()/3, height()-4);
            break;
        case WSGSpec::Y:
            painter.translate( 4, height()/3 );
            painter.rotate(90);
            break;
    }
    painter.drawText(QPoint(0,0), _text.c_str());
    painter.resetTransform();
}

void LabelWidget::SetText(const std::string &text, WSGSpec::AXIS axis)
{
    _text = text;
    _axis = axis;
    update();
}
