#include "cluswavewidget.h"

ClusWaveWidget::ClusWaveWidget(QWidget* parent) : WaveWidget(parent), _samplesBegin(-1), _samplesEnd(-1)
{
}

void ClusWaveWidget::mousePressEvent(QMouseEvent* event)
{
    setCursor(Qt::ClosedHandCursor);
    _mouseYPos = event->y();
}
void ClusWaveWidget::mouseMoveEvent(QMouseEvent* event)
{
    wv::float_t yrange = AbsoluteYMax() - AbsoluteYMin(),
            yrange_px = height(),
            delta_y_px = event->y() - _mouseYPos,
            delta_y = yrange * delta_y_px / yrange_px;

    SetAxisAbsoluteYRange( AbsoluteYMin()+delta_y, AbsoluteYMax()+delta_y );

    _mouseYPos = event->y();
    update();
}
void ClusWaveWidget::mouseReleaseEvent(QMouseEvent*)
{
    setCursor(Qt::ArrowCursor);
}

void ClusWaveWidget::wheelEvent(QWheelEvent* event)
{
    wv::float_t absolute_ymin = AbsoluteYMin(),
            absolute_ymax = AbsoluteYMax();

    wv::float_t num_degrees = event->delta() / 8.0,
            delta_pct = num_degrees/360.0,
            delta = delta_pct * (absolute_ymax-absolute_ymin) / 2.0;

    SetAxisAbsoluteYRange( absolute_ymin+delta, absolute_ymax-delta );

    event->accept();
    update();
}
