#ifndef CENTERSPEC_H
#define CENTERSPEC_H

#include "drawlinebase.h"

struct CenterSpec : DrawLineBaseSpec
{
    CenterSpec(wv::TRANSFORM tr_x, wv::TRANSFORM tr_y, int s_x, int s_y, wv::float_t x, wv::float_t y)
        : DrawLineBaseSpec(tr_x, tr_y, s_x, s_y, nullptr), val_x(x), val_y(y)
    {}
    CenterSpec(const CenterSpec& cs) : DrawLineBaseSpec(cs)
    {
        val_x = cs.val_x;
        val_y = cs.val_y;
    }

    virtual ~CenterSpec() override {}

    virtual DrawLineBase* GetDrawLine() override
    {
        throw BadGuiOp("CenterSpec::GetDrawLine", "CenterSpec doesn't have an associated DrawLine object");
    }
    virtual const DrawLineBase* GetDrawLine() const override
    {
        throw BadGuiOp("CenterSpec::GetDrawLine", "CenterSpec doesn't have an associated DrawLine object");
    }

    wv::float_t val_x, val_y;
};

#endif // CENTERSPEC_H
