#ifndef HISTTHREADMGR_H
#define HISTTHREADMGR_H

#include "../../globals/globals.h"
#include "../../gui/wavespaceguispec.h"
#include "../../analysis/threads/mgr/threadmgr.h"

class WorkerTO;
class HistThreadMgr : public ThreadMgr
{
    public:
        explicit HistThreadMgr(const Spec::HistSpec& hist_spec);

        virtual WorkerTO* CreateWorkerTO(int thd_num);
        gsl_histogram2d* HistAccept() { return _histAccept; }
        gsl_histogram2d* HistUnaccept() { return _histUnaccept; }

    protected:
        virtual void OnThreadFinished(void* result);

    private:
        const Spec::HistSpec& _histSpec;
        gsl_histogram2d* _histAccept, * _histUnaccept;
        int _recordsPerThread;
};

#endif // HISTTHREADMGR_H
