#include "histwgtthreadmgr.h"
#include "histwgtto.h"

HistWgtThreadMgr::HistWgtThreadMgr(uchar* pixels, const HistWidget* hist_widget, double max_val) : ThreadMgr(qMax( QThread::idealThreadCount()-1, 1), 2000),
      _pixels(pixels), _histWidget(hist_widget), _maxVal(max_val)
{
}
WorkerTO* HistWgtThreadMgr::CreateWorkerTO(int thd_num)
{
    int hist_ht = _histWidget->HistHeight(),
            cols_per_thread = hist_ht / NumThreads();
    int jstart = thd_num * cols_per_thread,
            jend = (thd_num== NumThreads()-1)
            ? hist_ht
            : jstart + cols_per_thread;
    HistWgtTO* to = new HistWgtTO(thd_num, _pixels, _histWidget, jstart, jend, _maxVal);
    return to;
}

