#include "spcparameters.h"

SPCParameters::SPCParameters() : ClusterParamsBase("Superparamagnetic")
{
    Insert("samples_begin", "-1", true);
    Insert("samples_end", "-1", true);
    Insert("Dimensions", "-1", true); //This signifies a wfm file
    Insert("Temperature", "auto"); //If this is instead a number, then this value will be
        //user, otherwise temperature is calculated using Quian-Quiroga's heuristic (which
        //is much slower).
    Insert("MinTemp", "0.0");
    Insert("MaxTemp", "0.2");
    Insert("TempStep", "0.01");
    Insert("MinClusterSizePct", "1"); //I.e., any cluster must contain at least this %
        //of all the spikes
    Insert("MaxPossibleClusters", "4"); //A priori limit on the number of possible clusters in the
        //data.
    Insert("SWCycles", "500"); //Note that this is set to 2000 for 4800x2 data,
        //to 4000 for 8100x1 data in demo files
    Insert("KNearestNeighbors", "11");
    Insert("MSTree", "|");
    Insert("DirectedGrowth","|");
    Insert("SaveSuscept", "|");
    Insert("WriteLabels", "|");
    Insert("WriteCorFile", "~");
}
