#ifndef HISTSPEC_H
#define HISTSPEC_H

//For histogram thread objects.  start_row and end_row are used only when this is sent from HistThreadMgr
//to the individual HistTOs
struct HistSpec
{
    HistSpec(const boost::dynamic_bitset<>& is_accepted_, const WaveSpaceGuiSpec& spec_)
        : has_accepted(is_accepted_.count()>0), is_accepted(is_accepted_), spec(spec_),
        start_row(-1), end_row(-1)
    {}
    const bool has_accepted;
    const boost::dynamic_bitset<> is_accepted;
    const WaveSpaceGuiSpec& spec;
    int num_bins_x, num_bins_y,
            start_row, end_row;
    wv::float_t min_x, min_y, max_x, max_y;
    const wv_vector* xdata_vec, * ydata_vec;
};

#endif // HISTSPEC_H
