#ifndef USERTRANSFORMSPEC_H
#define USERTRANSFORMSPEC_H

#include "../../globals/globals.h"
#include "../../globals/log.h"

// ***Only*** setter/getter, add/remove methods in this and all specs classes
typedef std::vector< std::pair<wv::TRANSFORM, int> > Signature;

class UserTransformSpec
{
    public:
        UserTransformSpec(wv::TRANSFORM_ID id) : _id(id) {}
        UserTransformSpec() : _id(_userTransformId++) {}
        void AddVector(wv_vector_const_view view, wv::TRANSFORM transform, int sample);
        void RemoveVector(int col);

        void SetWaves(MatPtr waves) { _waves = waves; }

        wv::TRANSFORM_ID ID() const { return _id; }
        int NumSpecs() const { return _signature.size(); }
        const std::pair<wv::TRANSFORM, int>& UserSpec(int i) const { return _signature.at(i); }
        const Signature& UserSpecs() const { return _signature; }
        MatPtr& Waves() { return _waves; }
        const MatPtr& Waves() const { return _waves; }

    private:
        static int _userTransformId;
        wv::TRANSFORM_ID _id;
        MatPtr _waves;
        Signature _signature;
};
typedef UserTransformSpec UTS;

#endif // USERTRANSFORMSPEC_H
